	<?php if ($frontend_controller->reviews): ?>
		<table class="w2dc-table w2dc-dashboard-reviews w2dc-table-striped">
			<tr>
				<th class="w2dc-td-review-title"><?php _e('Title', 'W2DC'); ?></th>
				<th class="w2dc-td-review-listing"><?php _e('Listing', 'W2DC'); ?></th>
				<th class="w2dc-td-review-date"><?php _e('Date', 'W2DC'); ?></th>
				<th class="w2dc-td-review-options"></th>
			</tr>
		<?php foreach ($frontend_controller->reviews AS $review): ?>
			<?php $listing = $review->listing; ?>
			<tr>
				<td class="w2dc-td-review-title">
				<?php if (w2dc_current_user_can_edit_review($review->post->ID)): ?>
				<a href="<?php echo w2dc_get_edit_review_link($review->post->ID); ?>"><?php echo $review->title(); ?></a> <?php $review->renderStars(); ?>
				<?php else: ?>
				<?php echo $review->title(); ?>
				<?php endif; ?>
				<?php if ($review->post->post_status == 'pending') echo ' - ' . __('Pending review', 'W2DC'); ?>
				</td>
				<td class="w2dc-td-listing-title">
					<?php if (w2dc_current_user_can_edit_listing($listing->post->ID)): ?>
					<a href="<?php echo w2dc_get_edit_listing_link($listing->post->ID); ?>"><?php echo $listing->title(); ?></a>
					<?php else: ?>
					<?php echo $listing->title(); ?>
					<?php endif; ?>
				</td>
				<td class="w2dc-td-listing-date">
					<?php echo get_the_date('', $review->post->ID) . ' ' . get_the_time('', $review->post->ID); ?>
				</td>
				<td class="w2dc-td-review-options">
					<?php if (w2dc_current_user_can_edit_review($review->post->ID)): ?>
					<div class="w2dc-btn-group">
						<a href="<?php echo w2dc_get_edit_review_link($review->post->ID); ?>" class="w2dc-btn w2dc-btn-primary w2dc-btn-sm w2dc-dashboard-edit-btn" title="<?php esc_attr_e('edit review', 'W2DC'); ?>"><span class="w2dc-glyphicon w2dc-glyphicon-edit"></span></a>
						<a href="<?php echo w2dc_get_edit_review_link($review->post->ID); ?>" class="w2dc-dashboard-btn-mobile"><?php _e('edit', 'W2DC'); ?></a>
						<?php
						if (get_option('w2dc_enable_stats')) {
							echo '<a href="' . w2dc_dashboardUrl(array('w2dc_action' => 'view_review_stats', 'review_id' => $review->post->ID)) . '" class="w2dc-btn w2dc-btn-primary w2dc-btn-sm w2dc-dashboard-stats-btn" title="' . esc_attr__('view clicks stats', 'W2DC') . '"><span class="w2dc-glyphicon w2dc-glyphicon-signal"></span></a>';
							echo '<a href="' . w2dc_dashboardUrl(array('w2dc_action' => 'view_review_stats', 'review_id' => $review->post->ID)) . '" class="w2dc-dashboard-btn-mobile">' . __('stats', 'W2DC') . '</a>';
						}?>
						<?php
						if ($permalink = get_permalink($review->post->ID)) {
							echo '<a href="' . $permalink . '" class="w2dc-btn w2dc-btn-primary w2dc-btn-sm w2dc-dashboard-view-btn" title="' . esc_attr__('view review', 'W2DC') . '"><span class="w2dc-glyphicon w2dc-glyphicon-link"></span></a>';
							echo '<a href="' . $permalink . '" class="w2dc-dashboard-btn-mobile">' . __('view', 'W2DC') . '</a>';
						}?>
						<?php do_action('w2dc_dashboard_review_options', $listing); ?>
					</div>
					<?php endif; ?>
				</td>
			</tr>
		<?php endforeach; ?>
		</table>
		<?php w2dc_renderPaginator($reviews_controller->query, '', false); ?>
		<?php endif; ?>